"use strict";Object.defineProperty(exports, "__esModule", { value: true });var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _requestPromise = require("request-promise");var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _logger = require("./logger");var _logger2 = _interopRequireDefault(_logger);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _defineProperty(obj, key, value) {if (key in obj) {Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });} else {obj[key] = value;}return obj;}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}

var MAP_CALL_FAILED = "Unable to call key value management endpoint.";
var CSRF_CALL_FAILED = "Unable to retrieve CSRF token.";
var PROXY_CALL_FAILED = "Unable to call API proxy management endpoint.";

var MAP_ENTITY_SET_URL = "/Management.svc/KeyMapEntries";
var PROXY_BASE_URL = "/Transport.svc/APIProxies";

var CSRF_HEADER = "x-csrf-token";

function odataLiteral(literal) {
    return "'" + (literal || "").replace("'", "''") + "'";
}

function wrapError(err, msg) {
    var message = void 0;
    if (!err) {
        message = msg;
    } else if (err.response) {
        message = msg + " Response status: " + err.response.statusCode + ". " + (
        typeof err.response.body === "string" ? err.response.body : JSON.stringify(err.response.body));
    } else {
        message = msg + " " + err.toString();
    }
    _logger2.default.error(message);
    throw new Error(msg);
}

function urlForSingleMap(name) {
    return MAP_ENTITY_SET_URL + "(" + odataLiteral(name) + ")";
}var

ApiClient = function () {
    function ApiClient(config) {_classCallCheck(this, ApiClient);
        if (!config.host || !config.username || !config.password) {
            throw new Error("The API Portal username, password and host are mandatory configuration attributes.");
        }
        var base = _requestPromise2.default.defaults({
            baseUrl: "https://" + config.host + "/apiportal/api/1.0",
            jar: true,
            proxy: config.proxy,
            resolveWithFullResponse: true,
            auth: {
                username: config.username,
                password: config.password } });


        this.client = base.head({ uri: "/Management.svc", headers: _defineProperty({}, CSRF_HEADER, "fetch") }).
        then(function (r) {return base.defaults({ headers: _defineProperty({}, CSRF_HEADER, r.headers[CSRF_HEADER] || "") });}).
        catch(function (r) {return wrapError(r, CSRF_CALL_FAILED);});
    }_createClass(ApiClient, [{ key: "deleteMap", value: function deleteMap(

        name) {
            return this.client.then(function (client) {return client.delete(urlForSingleMap(name));}).
            then(function () {return _logger2.default.debug("Successfully deleted map: " + name + ".");}).
            catch(function (r) {return (r && r.response && r.response.status) === 404 ? null : wrapError(r, MAP_CALL_FAILED);});
        } }, { key: "createMap", value: function createMap(

        name, content) {
            return this.client.then(function (client) {return client.post({ uri: MAP_ENTITY_SET_URL, body: content, json: true });}).
            then(function () {return _logger2.default.debug("Successfully created map: " + name + ".");}).
            catch(function (r) {return wrapError(r, MAP_CALL_FAILED);});
        } }, { key: "uploadProxy", value: function uploadProxy(

        data) {
            return this.client.
            then(function (client) {return client.post({
                    uri: PROXY_BASE_URL,
                    body: data,
                    headers: { "Content-Type": "application/octet-stream" } });}).

            then(function () {return _logger2.default.debug("Successfully uploaded proxy archive.");}).
            catch(function (r) {return wrapError(r, PROXY_CALL_FAILED);});
        } }, { key: "downloadProxy", value: function downloadProxy(

        name) {
            return this.client.
            then(function (client) {return client.get({ uri: PROXY_BASE_URL, qs: { name: name }, encoding: null });}).
            then(function (r) {_logger2.default.debug("Successfully downloaded proxy archive: " + name + ".");return r.body;}).
            catch(function (r) {return wrapError(r, PROXY_CALL_FAILED);});
        } }]);return ApiClient;}();exports.default = ApiClient;